if (!defined &_LINUX_ATARIINTS_H_) {
    eval 'sub _LINUX_ATARIINTS_H_ {1;}';
    require 'asm/irq.ph';
    require 'asm/atarihw.ph';
    eval 'sub STMFP_SOURCE_BASE {8;}';
    eval 'sub TTMFP_SOURCE_BASE {24;}';
    eval 'sub SCC_SOURCE_BASE {40;}';
    eval 'sub VME_SOURCE_BASE {56;}';
    eval 'sub VME_MAX_SOURCES {16;}';
    eval 'sub NUM_ATARI_SOURCES {( &VME_SOURCE_BASE+ &VME_MAX_SOURCES- &STMFP_SOURCE_BASE);}';
    eval 'sub IRQ_VECTOR_TO_SOURCE {
        local($v) = @_;
        eval "(($v) - (($v) < 0x20 ? 0x18 : (0x40-8)))";
    }';
    eval 'sub IRQ_SOURCE_TO_VECTOR {
        local($i) = @_;
        eval "(($i) + (($i) < 8 ? 0x18 : (0x40-8)))";
    }';
    eval 'sub IRQ_TYPE_SLOW {0;}';
    eval 'sub IRQ_TYPE_FAST {1;}';
    eval 'sub IRQ_TYPE_PRIO {2;}';
    eval 'sub IRQ_SPURIOUS {( &IRQ_MACHSPEC | 0);}';
    eval 'sub IRQ_AUTO_1 {( &IRQ_MACHSPEC | 1);}';
    eval 'sub IRQ_AUTO_2 {( &IRQ_MACHSPEC | 2);}';
    eval 'sub IRQ_AUTO_3 {( &IRQ_MACHSPEC | 3);}';
    eval 'sub IRQ_AUTO_4 {( &IRQ_MACHSPEC | 4);}';
    eval 'sub IRQ_AUTO_5 {( &IRQ_MACHSPEC | 5);}';
    eval 'sub IRQ_AUTO_6 {( &IRQ_MACHSPEC | 6);}';
    eval 'sub IRQ_AUTO_7 {( &IRQ_MACHSPEC | 7);}';
    eval 'sub IRQ_MFP_BUSY {( &IRQ_MACHSPEC | 8);}';
    eval 'sub IRQ_MFP_DCD {( &IRQ_MACHSPEC | 9);}';
    eval 'sub IRQ_MFP_CTS {( &IRQ_MACHSPEC | 10);}';
    eval 'sub IRQ_MFP_GPU {( &IRQ_MACHSPEC | 11);}';
    eval 'sub IRQ_MFP_TIMD {( &IRQ_MACHSPEC | 12);}';
    eval 'sub IRQ_MFP_TIMC {( &IRQ_MACHSPEC | 13);}';
    eval 'sub IRQ_MFP_ACIA {( &IRQ_MACHSPEC | 14);}';
    eval 'sub IRQ_MFP_FDC {( &IRQ_MACHSPEC | 15);}';
    eval 'sub IRQ_MFP_ACSI { &IRQ_MFP_FDC;}';
    eval 'sub IRQ_MFP_FSCSI { &IRQ_MFP_FDC;}';
    eval 'sub IRQ_MFP_IDE { &IRQ_MFP_FDC;}';
    eval 'sub IRQ_MFP_TIMB {( &IRQ_MACHSPEC | 16);}';
    eval 'sub IRQ_MFP_SERERR {( &IRQ_MACHSPEC | 17);}';
    eval 'sub IRQ_MFP_SEREMPT {( &IRQ_MACHSPEC | 18);}';
    eval 'sub IRQ_MFP_RECERR {( &IRQ_MACHSPEC | 19);}';
    eval 'sub IRQ_MFP_RECFULL {( &IRQ_MACHSPEC | 20);}';
    eval 'sub IRQ_MFP_TIMA {( &IRQ_MACHSPEC | 21);}';
    eval 'sub IRQ_MFP_RI {( &IRQ_MACHSPEC | 22);}';
    eval 'sub IRQ_MFP_MMD {( &IRQ_MACHSPEC | 23);}';
    eval 'sub IRQ_TT_MFP_IO0 {( &IRQ_MACHSPEC | 24);}';
    eval 'sub IRQ_TT_MFP_IO1 {( &IRQ_MACHSPEC | 25);}';
    eval 'sub IRQ_TT_MFP_SCC {( &IRQ_MACHSPEC | 26);}';
    eval 'sub IRQ_TT_MFP_RI {( &IRQ_MACHSPEC | 27);}';
    eval 'sub IRQ_TT_MFP_TIMD {( &IRQ_MACHSPEC | 28);}';
    eval 'sub IRQ_TT_MFP_TIMC {( &IRQ_MACHSPEC | 29);}';
    eval 'sub IRQ_TT_MFP_DRVRDY {( &IRQ_MACHSPEC | 30);}';
    eval 'sub IRQ_TT_MFP_SCSIDMA {( &IRQ_MACHSPEC | 31);}';
    eval 'sub IRQ_TT_MFP_TIMB {( &IRQ_MACHSPEC | 32);}';
    eval 'sub IRQ_TT_MFP_SERERR {( &IRQ_MACHSPEC | 33);}';
    eval 'sub IRQ_TT_MFP_SEREMPT {( &IRQ_MACHSPEC | 34);}';
    eval 'sub IRQ_TT_MFP_RECERR {( &IRQ_MACHSPEC | 35);}';
    eval 'sub IRQ_TT_MFP_RECFULL {( &IRQ_MACHSPEC | 36);}';
    eval 'sub IRQ_TT_MFP_TIMA {( &IRQ_MACHSPEC | 37);}';
    eval 'sub IRQ_TT_MFP_RTC {( &IRQ_MACHSPEC | 38);}';
    eval 'sub IRQ_TT_MFP_SCSI {( &IRQ_MACHSPEC | 39);}';
    eval 'sub IRQ_SCCB_TX {( &IRQ_MACHSPEC | 40);}';
    eval 'sub IRQ_SCCB_STAT {( &IRQ_MACHSPEC | 42);}';
    eval 'sub IRQ_SCCB_RX {( &IRQ_MACHSPEC | 44);}';
    eval 'sub IRQ_SCCB_SPCOND {( &IRQ_MACHSPEC | 46);}';
    eval 'sub IRQ_SCCA_TX {( &IRQ_MACHSPEC | 48);}';
    eval 'sub IRQ_SCCA_STAT {( &IRQ_MACHSPEC | 50);}';
    eval 'sub IRQ_SCCA_RX {( &IRQ_MACHSPEC | 52);}';
    eval 'sub IRQ_SCCA_SPCOND {( &IRQ_MACHSPEC | 54);}';
    eval 'sub INT_CLK {24576;}';
    eval 'sub INT_TICKS {246;}';
    eval 'sub MFP_ENABLE {0;}';
    eval 'sub MFP_PENDING {1;}';
    eval 'sub MFP_SERVICE {2;}';
    eval 'sub MFP_MASK {3;}';
}
1;
