if (!defined &_M68K_IDE_H) {
    eval 'sub _M68K_IDE_H {1;}';
    require 'linux/config.ph';
    if (defined &CONFIG_AMIGA) {
	require 'asm/amigahw.ph';
	require 'asm/amihdreg.ph';
	require 'asm/amigaints.ph';
    }
    if (defined &CONFIG_ATARI) {
	require 'asm/atarihw.ph';
	require 'asm/atarihdreg.ph';
	require 'asm/atariints.ph';
	require 'asm/atari_stdma.ph';
    }
    require 'asm/setup.ph';
    eval 'sub IDE_MEM_MAPPED_IO {1;}';
    if (!defined &MAX_HWIFS) {
	eval 'sub MAX_HWIFS {1;}';
    }
    eval 'sub SUPPORT_VLB_SYNC {0;}';
    eval 'sub SUPPORT_SLOW_DATA_PORTS {0;}';
    eval 'sub HD_DATA { &NULL;}';
    if (defined( &CONFIG_ATARI) && !defined( &CONFIG_AMIGA)) {
	eval 'sub STI {
	    eval " &do {  &if (! &intr_count)  &sti(); }  &while(0)";
	}';
    }
    elsif (defined( &CONFIG_ATARI)) {
	eval 'sub STI {
	    eval " &do {  &if (! &MACH_IS_ATARI || ! &intr_count)  &sti(); }  &while(0)";
	}';
    }
    else {
	eval 'sub STI {
	    eval " &sti()";
	}';
    }
    eval 'sub insl {
        local($data_reg, $buffer, $wcount) = @_;
        eval " &insw($data_reg, $buffer, ($wcount)<<1)";
    }';
    eval 'sub outsl {
        local($data_reg, $buffer, $wcount) = @_;
        eval " &outsw($data_reg, $buffer, ($wcount)<<1)";
    }';
    eval 'sub insw {
        local($port, $buf, $nr) = @_;
        eval " &if (($nr) % 16)  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 subql #1,%/d6; 	       1:movew %/a0@,%/a1@+; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"a0\\", \\"a1\\", \\"d6\\");  &else  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 lsrl  #4,%/d6; 		 subql #1,%/d6; 	       1:movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 movew %/a0@,%/a1@+; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"a0\\", \\"a1\\", \\"d6\\")";
    }';
    eval 'sub outsw {
        local($port, $buf, $nr) = @_;
        eval " &if (($nr) % 16)  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 subql #1,%/d6; 	       1:movew %/a1@+,%/a0@; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"a0\\", \\"a1\\", \\"d6\\");  &else  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 lsrl  #4,%/d6; 		 subql #1,%/d6; 	       1:movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 movew %/a1@+,%/a0@; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"a0\\", \\"a1\\", \\"d6\\")";
    }';
    if (defined &CONFIG_ATARI) {
	eval 'sub insl_swapw {
	    local($data_reg, $buffer, $wcount) = @_;
	    eval " &insw_swapw($data_reg, $buffer, ($wcount)<<1)";
	}';
	eval 'sub outsl_swapw {
	    local($data_reg, $buffer, $wcount) = @_;
	    eval " &outsw_swapw($data_reg, $buffer, ($wcount)<<1)";
	}';
	eval 'sub insw_swapw {
	    local($port, $buf, $nr) = @_;
	    eval " &if (($nr) % 8)  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 subql #1,%/d6; 	       1:movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"d0\\", \\"a0\\", \\"a1\\", \\"d6\\");  &else  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 lsrl  #3,%/d6; 		 subql #1,%/d6; 	       1:movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 movew %/a0@,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a1@+; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"d0\\", \\"a0\\", \\"a1\\", \\"d6\\")";
	}';
	eval 'sub outsw_swapw {
	    local($port, $buf, $nr) = @_;
	    eval " &if (($nr) % 8)  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 subql #1,%/d6; 	       1:movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"d0\\", \\"a0\\", \\"a1\\", \\"d6\\");  &else  &__asm__  &__volatile__ (\\"movel %0,%/a0; 		 movel %1,%/a1; 		 movel %2,%/d6; 		 lsrl  #3,%/d6; 		 subql #1,%/d6; 	       1:movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 movew %/a1@+,%/d0; 		 rolw  #8,%/d0; 		 movew %/d0,%/a0@; 		 dbra %/d6,1b\\" : : \\"g\\" ($port), \\"g\\" ($buf), \\"g\\" ($nr) : \\"d0\\", \\"a0\\", \\"a1\\", \\"d6\\")";
	}';
    }
    eval 'sub T_CHAR {(0x0000);}';
    eval 'sub T_SHORT {(0x4000);}';
    eval 'sub T_INT {(0x8000);}';
    eval 'sub T_TEXT {(0xc000);}';
    eval 'sub T_MASK_TYPE {(0xc000);}';
    eval 'sub T_MASK_COUNT {(0x3fff);}';
    eval 'sub D_CHAR {
        local($cnt) = @_;
        eval "( &T_CHAR | ($cnt))";
    }';
    eval 'sub D_SHORT {
        local($cnt) = @_;
        eval "( &T_SHORT | ($cnt))";
    }';
    eval 'sub D_INT {
        local($cnt) = @_;
        eval "( &T_INT | ($cnt))";
    }';
    eval 'sub D_TEXT {
        local($cnt) = @_;
        eval "( &T_TEXT | ($cnt))";
    }';
    eval 'sub num_driveid_types {($sizeof{ &driveid_types}/$sizeof{* &driveid_types});}';
}
1;
